package de.ivu.elect.was.exchange.wahl;

import de.ivu.elect.business.mandant.entity.EntityPKMitMandant;
import de.ivu.elect.business.system.control.AbstractElectMultipleCronTimer;
import de.ivu.elect.business.system.control.AbstractElectMultipleCronTimerAsync;
import de.ivu.elect.business.wahl.entity.WahlPK;
import de.ivu.elect.business.wahl.entity.WahlParameterWerte;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.ejb.DependsOn;
import javax.ejb.EJB;
import javax.ejb.Singleton;
import javax.ejb.Startup;

import static de.ivu.elect.business.wahl.entity.WahlParameterWerte.WAHLEXPORT_CRONTAB;

/**
 *  on 03.01.2017.
 */
@Startup
@Singleton
@DependsOn("StartupSingleton")
public class AutomatischerWahlExportCronTimer extends AbstractElectMultipleCronTimer<WahlPK> {

  private static final Logger LOG = LoggerFactory.getLogger(AutomatischerWahlExportCronTimer.class);

  @EJB
  AutomatischerWahlExportAsync async;

  @Override
  protected Logger getLog() {
    return LOG;
  }

  @Override
  protected AbstractElectMultipleCronTimerAsync<WahlPK> getAsync() {
    return async;
  }

  @Override
  protected WahlParameterWerte getWahlParameterWerte() {
    return WAHLEXPORT_CRONTAB;
  }

  @Override
  protected EntityPKMitMandant bestimmeMandantAusPayload(WahlPK wahlPK) {
    return bestimmeMandant(wahlPK);
  }

}
